.386
.model flat,stdcall
option casemap:none

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
include    \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
RegisterNewClass PROTO :DWORD,:DWORD,:DWORD

.data

DlgBox      db 'DLGBOX',0
DlgBoxClass db '#32770',0   ; This is the default class for dialog boxes

ClassName1  db 'DlgboxClass31415',0
                            ;  New class name to replace #32770
                            
errmsg      db 'The application is already running',0
capt        db 'Error',0


.data?

hModule     dd ?

.code

start:

    invoke  FindWindow,ADDR ClassName1,0
    test    eax,eax
    jz      @f
   
    invoke  MessageBox,0,ADDR errmsg,ADDR capt,MB_ICONEXCLAMATION
    invoke  ExitProcess,eax
@@:

    invoke  GetModuleHandle,0
    mov     hModule,eax

    invoke  RegisterNewClass,eax,ADDR DlgBoxClass,ADDR ClassName1

    invoke  DialogBoxParam,hModule,ADDR DlgBox,0,ADDR DlgProc,0
    invoke  ExitProcess,eax


DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .IF uMsg==WM_CLOSE

            invoke  EndDialog,hWnd,0
    .ELSE
            xor     eax,eax
            ret

    .ENDIF

    mov     eax,1
    ret

DlgProc ENDP


RegisterNewClass PROC USES esi hMod:HMODULE,OldClassName:DWORD,NewClassName:DWORD

LOCAL wc:WNDCLASSEX

    lea     esi,wc
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    invoke  GetClassInfoEx,hMod,OldClassName,esi

    push    hMod
    pop     wc.hInstance 
    mov     eax,NewClassName
    mov     WNDCLASSEX.lpszClassName[esi],eax

    invoke  RegisterClassEx,esi
    ret

RegisterNewClass ENDP

END start
